#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import tkinter
import socket
import threading
import json
import urllib.parse
import subprocess
import os

HOST = 'localhost'
PORT1 = 60000
PORT2 = 60001
MAX_BUFFER = 2048
NUM_THREAD = 4


def quit():
    root.quit()
    root.destroy()
    os._exit(0)

def assist_open():
    print("OPEN")
    mes = "assist_open"
    if(bln.get()):
        mes += "/speak_open"
    else:
        mes += "/speak_close"
    
    send_message(mes)

def send_message(mes):
    while True:
        try:
            s_sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s_sock.connect((HOST, PORT1))
            s_sock.send(mes.encode('utf-8'))
            s_sock.close()
            break
            
        except:
            print ('error: ' + mess)
            break

def show_responce(reception):
    obj = json.loads(reception)
    
    resp1 = obj['resp1']
    resp2 = obj['resp2']
    resp = "【" + resp1 + "】" + "\n\n" + resp2
    print(resp)
    textBox.delete('1.0','end')
    textBox.insert('1.0',resp)
    toEnd()

def toEnd():
    textBox.see('end')

def receive_responce():
    r_sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    r_sock.bind ((HOST, PORT2))
    r_sock.listen (NUM_THREAD)
    
    while True:
        try:
            conn,addr = r_sock.accept()
            reception = conn.recv(MAX_BUFFER).decode('utf-8')
            conn.close()
            print('RECEPT:' + reception)
            show_responce(reception)
        
        except:
            print('Receive Error')
    
    r_sock.close()

def receive_start():
    th=threading.Thread(target=receive_responce)
    th.start()

root = tkinter.Tk()
root.title(u"Google Assistant")
root.geometry("400x400")
root.resizable(0,0)
root.protocol('WM_DELETE_WINDOW', quit)
bln = tkinter.BooleanVar()

#チェックボックス
chkBox = tkinter.Checkbutton(master=root,variable=bln,width=60, text='音声も再生する')
chkBox.place(x=50,y=0)

#ボタン
button1 = tkinter.Button(master=root, text="音声入力", width=15, bg="#ff6633", command=assist_open)
button1.place(x=0,y=0)

#テキストボックス
textBox = tkinter.Text(master=root,width=50,font=("",10))
textBox.place(x=0,y=30)


receive_start()
root.mainloop()


